/*
 * PtokaX - hub server for Direct Connect peer to peer network.

 * Copyright (C) 2002-2005  Ptaczek, Ptaczek at PtokaX dot org
 * Copyright (C) 2004-2014  Petr Kozelka, PPK at PtokaX dot org

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//---------------------------------------------------------------------------
#ifndef hashRegManagerH
#define hashRegManagerH
//---------------------------------------------------------------------------
struct User;
//---------------------------------------------------------------------------

struct RegUser {
    char *sNick;
    char *sPass;
    time_t tLastBadPass;
    uint16_t ui16Profile;
	// alex82 ...     
	time_t tRegDate;
	time_t tLastEnter;
	time_t tOnlineTime;
	// alex82 ...      
	char *sCustom;
    uint32_t ui32Hash;
    RegUser *prev, *next;
    RegUser *hashtableprev, *hashtablenext;
    unsigned char ui8BadPassCount;

    RegUser(char * Nick, char * Pass, const uint16_t &iProfile, const time_t &RegDate, const time_t &LastEnter, const time_t &OnlineTime);
    ~RegUser(void);
}; 
//---------------------------------------------------------------------------

class clsRegManager {
private:
    RegUser *table[65536];

    uint8_t ui8SaveCalls;
public:
    static clsRegManager * mPtr;

    RegUser *RegListS, *RegListE;

    clsRegManager(void);
    ~clsRegManager(void);

    bool AddNew(char * sNick, char * sPasswd, const uint16_t &iProfile);

    void Add(RegUser * Reg);
    void Add2Table(RegUser * Reg);
    static void ChangeReg(RegUser * pReg, char * sNewPasswd, const uint16_t &ui16NewProfile);
	// alex82 ...      
	void SetCustom(RegUser * pReg, char * sCustom, const size_t &szCustomLen);
    void Delete(RegUser * pReg, const bool &bFromGui = false);
    void Rem(RegUser * Reg);
    void RemFromTable(RegUser * Reg);

    RegUser* Find(char * sNick, const size_t &szNickLen);
    RegUser* Find(User * u);
    RegUser* Find(uint32_t hash, char * sNick);

	// alex82 ...          
	void UpdateTimes(void);
	
    void Load(void);
    void Save(const bool &bSaveOnChange = false, const bool &bSaveOnTime = false);
};
//---------------------------------------------------------------------------

#endif
